#include "Mac Vars.h"
#include "Failure.h"

#undef EXTERN
#define EXTERN extern
#include "StringUtils.h"
#include "Use DrawSprockets.h"
#include "Palette.h"

#include <Resources.h>

#ifdef Joolz
#include <stdarg.h>
#include "error.h"



//==================================================================




void showFailure(ConstStr255Param unixStr)
{
	Str255		macStr;
	short		i;

	// Disgusting hackery to convert LFs to CRs for the Mac error string.

	macStr[0] = unixStr[0];

	for (i = 1; i <= unixStr[0]; ++i)
		macStr[i] = (unixStr[i] == 10) ? 13 : unixStr[i];

	SetCursor(&qd.arrow);
	ParamText(macStr, nil, nil, nil);
	Alert(32765, nil);
}



void fatal_error(char *fmt, ...)
{
	va_list	args;
	char	buf[256];

	va_start(args, fmt);
	buf[0] = vsprintf(buf+1, fmt, args);
	va_end(args);

	showFailure((StringPtr)buf);
	ExitToShell();
}
#endif


void Fail(OSErr ErrorID, char *FileName, short LineNum, Boolean Fatal, Str255 text)
{
	Str255	theErrNum,theLineNum;
	
	NumToString(LineNum, theLineNum);
	NumToString(ErrorID, theErrNum);
	
	c2p(FileName);
	
	ParamText(theErrNum, theLineNum, (StringPtr)FileName, (StringPtr)text);
	RevertToMac();
	SetCursor(&qd.arrow);
	if ( Fatal )
		{
		StopAlert(ErrorBox, nil);
		ExitToShell();
		}
	else
		StopAlert(ErrorBox, nil);
	RevertToGame();
}

