#include "Andys Vars.h"
#include "Maths.h"

#undef EXTERN
#define EXTERN extern

extern short *afr1;
extern short *afr2;

/******************************************************************************
*****************************************************************************/

//extern int matherr(struct exception *);

int matherr(struct exception *)
{
//	keys[0x01]=1;			// Simulate escape.
	return(0);
}

/******************************************************************************
*****************************************************************************/

void af_randomize()
{
	if (andys_random)
	{
		rand_seed=(*afr1)^rand_seed+(*afr2)^rand_seed;
		*afr1=*afr1^((int)rand_seed);
		*afr2=*afr2^((int)-(rand_seed*rand_seed))+9;
		if (!(*(++afr1)))
			afr1=rand1_tab;
		if (!(*(++afr2)))
			afr2=rand2_tab;
	}
	else
	{
		rand_seed=rand_seed^rand();
	}

	seed=rand_seed&127;

}

/******************************************************************************
*****************************************************************************/

void random_vector(float &a,float &b)
{
	double n;
	signed short ang=rand_seed&65535;
	float ab=modf(((float)ang/PI),&n);
	a=cos(ab);
	b=sin(ab);
}

/******************************************************************************
*****************************************************************************/

// Returns a random value of ( 0 -> (Range-1) )

int rand_range(int range)
{
	int rs=(seed*range)/128;
	return(rs);
}

/******************************************************************************
*****************************************************************************/
 
float calc_dist(float x,float y)
{
	float r;
	r=sqrt((x*x)+(y*y));
	if (r>0.1)
		return(r);
	else
		return(0.1);
}


