#include "Mac Vars.h"
#include "Apple Menu.h"

#undef EXTERN
#define EXTERN extern
#include "Actua.Soccer.h"
#include "Blitter.h"
#include "Flc Player.h"
#include "Sprocket Input.h"
#include <Resources.h>

extern BYTE *psudo_buffer;

/*
** File:		Menu.c
**
** Written by:	Bill Hayden
**				Nikol Software
**
** Copyright  1995 Nikol Software
** All rights reserved.
*/



/*****************************************************************************/
static	Boolean EventProc( EventRecord *event)
{
	return false;
}


/*****************************************************************************/
static void		EnableOrDisableItem(MenuHandle menu, short item, Boolean enable);

/*****************************************************************************/
/* This is called when an item is chosen from the menu bar (after calling
** MenuSelect or MenuKey).  It performs the right operation for each command.
** It is good to have both the result of MenuSelect and MenuKey go to one
** routine like this to keep everything organized. */

void	DoMenuCommand(long menuResult)
{
short		menuID, menuItem, daRefNum;
Str255		str;

	menuID = HiWord(menuResult);	/* Use macros for efficiency to get  */
	menuItem = LoWord(menuResult);	/* menu item number and menu number. */

	switch (menuID) {

		case mApple:
			switch (menuItem)
			  {
			  case kAbout:		/* Bring up alert for About. */
					Alert(rAboutAlert, nil);
					break;
					
			  default:			/* All non-About items in this menu are DAs. */
					GetMenuItemText(GetMenuHandle(mApple), menuItem, str);
					daRefNum = OpenDeskAcc(str);
					break;
			  }
			break;

		case mFile:
			switch (menuItem)
			  {
			  case kResume:
					gQuitting = 2;
					break;

	          case kConfigureInput:
					Input_Configure();
					break;

	          case kConfigureSound:
//					SSpConfigureSetup( EventProc);
					break;

			  case kQuit:
					gQuitting = TRUE;
					break;
			  }
			break;

	}

	HiliteMenu(0);		/* Unhighlight what MenuSelect (or MenuKey) hilited. */
}



/*****************************************************************************/



Boolean	DoAdjustMenus(WindowPtr window)
{
MenuHandle	menu;

// Adjust File Menu
	menu = GetMenuHandle(mFile);
	EnableItem(menu, kQuit);			/* Gotta be able to quit. */

//	EnableOrDisableItem(menu, kNew, !gGameOn);
//	EnableOrDisableItem(menu, kShowFPS, !gShowFPS);
//	EnableOrDisableItem(menu, kUseQuickdraw, !gTrueColor);
//	EnableOrDisableItem(menu, kDebugMode, gDebugMode);

//	SetItemMark(menu, kShowFPS, (gShowFPS) ? checkMark : noMark);
//	SetItemMark(menu, kUseQuickdraw, (gUseQuickdraw) ? checkMark : noMark);
//	SetItemMark(menu, kDebugMode, (gDebugMode) ? checkMark : noMark);

	return(false);
}

/*****************************************************************************/
/* This function either enables or disables a menu item. */
#if 0
static	void	EnableOrDisableItem(MenuHandle menu, short item, Boolean enable)
{
	if (enable)
		EnableItem(menu, item);
	else
		DisableItem(menu, item);
}
#endif

