#include "Mac Vars.h"
#include "Resource.h"

#undef EXTERN
#define EXTERN extern
#include "Frontend.h"
#include "3deng.h"
#include "Front Variables.h"
#include "Mallocx.h"

char *LoadBinary(long resType, short resID)
{
Handle Hand;

	Hand = GetResource( resType, resID );
	MarkX( Hand, GetHandleSize( Hand));
	if( Hand)
	  {
	  DetachResource( Hand); 
	  HLock( Hand);
	  }
	else
	  {
	  bomb_message |= MEMORY_PROBLEM;
	  return NULL;
	  }
	  
	return *Hand;
}

EXTERN Boolean LoadBinaryDirect(unsigned char *where, long resType, short resID)
{
Handle h;
Boolean ret = false;

	UseResFile( dataResFile);
	h = GetResource( resType, resID);
	if(h)
	  {
	  HLockHi(h);
	  memcpy( where, *h, GetHandleSize(h));
	  DetachResource(h);
	  DisposeHandle(h);
	  ret = true;
	  }	
	UseResFile( mainResFile);

	return ret;
}
