#include "Frontend Vars.h"
#include "Vbl.h"

#undef EXTERN
#define EXTERN extern
#include "Front Variables.h"
#include "Palette.h"

static long *taskPtr;
static VBLTask *theVblVBPtr;

void InitVBL( void)
{
OSErr theErr;

	theErr = noErr;
	taskPtr = NULL;
	
	theVblVBPtr = (VBLTask *)NewPtrSysClear( (long)sizeof(VBLTask));
	
	if( theVblVBPtr)
		{
		theVblVBPtr->vblAddr = NewVBLProc( ActuaSoccerVBL);
		theVblVBPtr->vblCount = 1;
		theVblVBPtr->qType = vType;
		theVblVBPtr->qLink = NULL;
		theVblVBPtr->vblPhase = 0;
		
		theErr = VInstall( (QElemPtr)theVblVBPtr);
		}
}

void EndVBL( void)
{
	if( theVblVBPtr)
		{
		if( theVblVBPtr->vblAddr)
			{
			DisposeRoutineDescriptor( (VBLUPP)theVblVBPtr->vblAddr);
			theVblVBPtr->vblAddr = NULL;
			}
		VRemove( (QElemPtr)theVblVBPtr);
		DisposePtr( (Ptr)theVblVBPtr);
		theVblVBPtr = NULL;
		}
}

Boolean ActuaSoccerVBL(VBLTaskPtr theVBLTask)
{

	theVblVBPtr->vblCount = 1;

	++VblTicks;

	if( GDVtimer)
		GDVtimer--;
	
	if( Timing)
	  {
//	  CheckTimers();

	  count++;
	  
	  ftick+=game_speed;
	  while(ftick>=TIMER_SPEED)
		ftick-=TIMER_SPEED;

	  if( VblTicks==TicksPerSecond)
	    {
	    VblTicks = 0;
	    FramesPerSecond = Frames;
	    Frames = 0;
	    }
	  }

	return false;
}

void AddTimer( int Speed, void (*address)(), int *handle)
{
/*
	Timer.Address = address;
	Timer.Speed = TicksPerSecond/(Speed/3);
	Timer.Tick = 0;
	Timer.Avail = true;
	*handle = true;
*/
}

void RemoveTimer( int handle)
{
/*
	Timer.Avail = false;
	Timer.Speed = 0;
	Timer.Address = NULL;
*/
}

void CheckTimers()
{
/*
	if(Timer.Avail)
		{
		Timer.Tick++;
		if( Timer.Tick == Timer.Speed)
		  {
		  Timer.Address();
		  Timer.Tick = 0;
		  }
		}
*/
}

