#include "Andys Vars.h"
#include "More Control.h"

#undef EXTERN
#define EXTERN extern
#include "Process Inputs.h"

extern int isth, icth;

static short ProcessX( short x, short y, short i)
{
int a,b;

	a=x*icth;
	b=y*isth;
	a=(a-b)>>15;

	if (a<-32767)
		a=-32767;
	else if (a>32767)
		a=32767;

	return a;
}

static short ProcessY( short x, short y, short i)
{
int a,b;

	a=y*icth;
	b=x*isth;
	a=(a+b)>>15;

	if (a<-32767)
		a=-32767;
	else if (a>32767)
		a=32767;

	return a;
}

void process_user_inputs(void)
{
int x,y,i,a,b;

	for (i=0; i<num_of_users; i++)
	  {
	  if (users[i].type)			// Not computer or net guy
		{
		switch(users[i].control)
		  {
		  case(KEY1_CTRL):
		  				users_dir_i[writeptr][i].x_f1 =  (ProcessX(Inputs.Player1_X, Inputs.Player1_Y, i) & 0xfffe) | Inputs.Player1_S;
						users_dir_i[writeptr][i].y_f2 =  (ProcessY(Inputs.Player1_X, Inputs.Player1_Y, i) & 0xfffe) | Inputs.Player1_P;
						break;
		  case(KEY2_CTRL):
		  				users_dir_i[writeptr][i].x_f1 =  (ProcessX(Inputs.Player2_X, Inputs.Player2_Y, i) & 0xfffe) | Inputs.Player2_S;
						users_dir_i[writeptr][i].y_f2 =  (ProcessY(Inputs.Player2_X, Inputs.Player2_Y, i) & 0xfffe) | Inputs.Player2_P;
						break;
		  case(JOY1_CTRL):
		  				users_dir_i[writeptr][i].x_f1 =  (ProcessX(Inputs.Player3_X, Inputs.Player3_Y, i) & 0xfffe) | Inputs.Player3_S;
						users_dir_i[writeptr][i].y_f2 =  (ProcessY(Inputs.Player3_X, Inputs.Player3_Y, i) & 0xfffe) | Inputs.Player3_P;
						break;
		  case(JOY2_CTRL):
		  				users_dir_i[writeptr][i].x_f1 =  (ProcessX(Inputs.Player4_X, Inputs.Player4_Y, i) & 0xfffe) | Inputs.Player4_S;
						users_dir_i[writeptr][i].y_f2 =  (ProcessY(Inputs.Player4_X, Inputs.Player4_Y, i) & 0xfffe) | Inputs.Player4_P;
						break;
		  case(NET_CTRL):
		  				break;
		  }
		}
	}
}
