#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sioux.h>

#define RESNAME		"\pActua Movie Res"
#define MYDATA		'ACTU'

void	main(void);
void	Process2(char *filename,long mydata, int resnum);
void	InitializeToolbox( void );

short	gResFile;

void main()
{
StandardFileReply reply;
OSErr       theError;
long		theResID;
short		oldFile;
short		resnum;

	InitializeToolbox();
	
	MaxApplZone();
	
//	SIOUXSettings.autocloseonquit = true;
	SIOUXSettings.asktosaveonclose = false;

	StandardPutFile("\pCreate Which Resource", RESNAME, &reply);
   		
	if(reply.sfGood == TRUE)
   		{
   		oldFile = CurResFile();
   
   		if(reply.sfReplacing == TRUE)
   			FSpDelete(&reply.sfFile);
     
  		FSpCreate(&reply.sfFile, 'RSED', MYDATA, 0);
   		FSpCreateResFile(&reply.sfFile, 'RSED', MYDATA, 0);
   
   		gResFile = FSpOpenResFile(&reply.sfFile, fsRdWrPerm);
   		UseResFile(gResFile);
  
		Process2(":Movies:Intro English.flc", 'FLC ', 1000);
				
		UseResFile(oldFile);
   		CloseResFile(gResFile);
		}
}

void Process2(char *filename,long mydata, int resnum)
{
FILE *fp=fopen(filename,"rb");
Handle theData;
int theSize, pos;

	if( fp)
		{
		printf("Processing %s\n",filename);
		theData = NewHandle(4000000); HLockHi(theData);
		theSize=fread(*theData, 1, 4000000, fp);
		SetHandleSize(theData, theSize);

		AddResource( (Handle)theData, mydata, resnum, "\p");
		WriteResource( (Handle)theData);
		DetachResource( (Handle)theData);
		HUnlock(theData);
		ReleaseResource( theData );
		DisposeHandle(theData);
		fclose(fp);
		}
	else
		printf("Could Not Find '%s'\n", filename);
}

void  InitializeToolbox( void )
{
   InitGraf( &qd.thePort );
   InitFonts();
   InitWindows();
   InitMenus();
   TEInit();
   InitDialogs( 0L );
   FlushEvents( everyEvent, 0 );
   InitCursor();
}

